2.6 Release (TBD) - First release as OpenRefine - Maintenance release

Features:

- Issue 144: Use subdirectory for archives (tar, zip)
- Issue 467: Provide feedback to user on JVM heap memory usage
- Issue 524: Shorten name of anonymous JSON nodes in column names

Bugs fixed:

- Issue 154: Can't import RDF/XML Data
- Issue 226: Load into freebase: date objects are not converted into proper freebase dates
- Issue 361: Headless operation on OS X leaves Dock icon bouncing
- Issue 390: Latest POI fixes some import issues
- Issue 432: cross() failing
- Issue 436: Google refine don't start on debian squeeze
- Issue 490: Unable to guess filetype is CSV when importing a simple CSV file
- Issue 496: google-refine-2.5-rc2-r2379 failed to start if using refine.ini
- Issue 515: "Open Project" page shows negative interval for "Last Modified"
- Issue 517: Combin() function does not work as intended
- Issue 521: Machine readable string (/type/rawstring) missing
- Issue 523: Return all available HTTP error information on when Fetch URL fails
- Issue 535: Refine fails to import Excel 2010 XLSX file with null hyperlinks
- Issue 537: ToNumber should try to convert to integer first
- Issue 541: Can't constrain a Freebase key query when using add column
- Issue 542: ToDate should work on integers
- Issue 543: Project creation from URL can't handle gzip Content-Encoding
- Issue 544: FileNotFound exception when importing archive from URL
- Issue 548: escape(value, encoding) returns "null" for non-string values
- Issue 551: MQL preview missing "insert" clause
- Issue 553: Upload Error - Not a directory
- Issue 554: Format guesser ranking isn't working correctly in some cases
- Issue 558: 'refine windows_dist' does not work on MacOS Lion
- Issue 559: Deadlock between autosave thread and history code
- Issue 578: json import on create project deletes useful blank data from arrays
- Issue 586: Only one parse date format is attempted from list in toDate(format1,format2)
- Issue 594: Date diff function doesn't work for two Calendar objects
- Issue 596: JSON importer should not deserialize nulls as the string "null"
- Issue 597: Deselect all button on Custom Tabular Exporter dialog doesn't work
- Issue 599: RDF/XML parser preview not wired up
- Issue 601: Allow selection of root element on JSON import
- Issue 604: The common transform “Trim leading and trailing whitespace” doesn’t trim non-breaking spaces


2.5 Release (December 11, 2011)

Major changes:
- Entirely new importer architecture and user interface for Create Project
- New import/export formats: Google Fusion Tables, OpenOffice Calc, 
  and fixed width (import only)

Features:

- Issue 131: Read multiple files in a directory
- Issue 179: Progress feedback during upload
- Issue 260: XML Importer silently fails if file doesn't meet its criteria
- Issue 279: Add support for reading from non-public Google Spreadsheets docs
- Issue 280: Spreadsheet/table importers should allow selection of sheet/table to import
- Issue 281: Add sheet selection support to Google Spreadsheet importer
- Issue  31: Maximum number of facet values should be configurable.
- Issue  38: Fix the table header so that it's always visible when scrolling a long page
- Issue 433: Usability: use HTML <label> (e.g., for checkboxes
- Issue 447: Extend toTitlecase() function with support for char[] delimiters in Apache WordUtils
- Issue 452: Importing using Clipboard function does not guess structure correctly for XML or JSON
- Issue 483: Project custom metadata while importing 
- Issue 504: Allow "sort" keyword in constraint subquery for "Add from Freebase"
- Issue  84: Add a cut and paste textbox importer
- Issue  85: Fixed width column importer
- Issue  88: Improve operation history robustness by fixing Json.
- Issue  92: Add Columns From Freebase dialog should support constraints
- Issue  97: Exporting CSV should allow for optional columns

Bugs fixed:

- Issue 149: rows button stays strike-through when clicking on it
- Issue 229: 'Ignore lines on import' bug when import from URL?
- Issue 232: Stray characters before <?xml> (including blank lines) causes XML import to fail
- Issue 233: 404 Error upon Launch
- Issue 313: Excel export loses date cell format
- Issue 314: Reconciliation (Freebase) of accented characters doesn't work
- Issue 330: On Project creation - Unchecked Split Columns Box still splits by comma
- Issue 366: Error when using Add column from Freebase on restored project
- Issue 375: Importing data from Google spreadsheet via visualisation API query
- Issue 378: Transform involving NaN causes crash
- Issue 383: Updating Preview hangs on 2.5 branch when checking Load at most...
- Issue 410: Convert line-endings to DOS format
- Issue 419: Values with Characters like é split across several lines
- Issue 424: Duplicate column names don't allow user to recover
- Issue 426: filter with custom facet adds zero lines choice
- Issue 428: Excel import sometimes drops last row of data
- Issue 430: Timeline Facet not working
- Issue 435: refine sh script only checks for java 1.6, not > 1.6
- Issue 440: Fetch URLs aborts while saving/loading/computing facets
- Issue 441: onError - "keep-original" / "store-blank" working oddly for value.toDate()
- Issue 442: Two column transforms to date on the same column turns the cells blank
- Issue 449: Uncaught exception from Excel importer
- Issue 450: Parse error uploading to Fusion Table
- Issue 454: Reselect Files after Configuring Parsing Options does not allow Select
- Issue 459: Undefined error with some CSV files (incorrectly detected as EXCEL) 
- Issue 462: Don't trim whitespace in Excel importer
- Issue 465: Data text file with extension .dta within a .ZIP is not automatically extracted
- Issue 473: Cancel button doesn't work during project creation
- Issue 474: XML importer ignores record limit
- Issue 475: New Importer does not accept special separator characters completely such as Unicode chars
- Issue 477: Implement or remove the line separator option
- Issue 487: Transform -> To Date doesn't support ISO 8601 date parsing
- Issue 488: ISO 8601 dates not supported in cell editing - cell-ui.js
- Issue 489: Custom Exporter no longer behaves as expected with line & field separators
- Issue 491: Importing Excel files - blank columns and time formatting
- Issue 492: Table header cells misaligning with table cells
- Issue 502: Fetch URLs does not return the exact HTTP payload, like Create Project from URLs does.
- Issue 513: No more Json Tokens in stream ERROR


2.1 Release (July 10, 2011) - Maintenance release

Features:

- Issue 157: Google Spreadsheet import/export plugin integrated
- Issue 220: HTML parsing functions added to GREL (using Jsoup)
- Issue 222: Added the ability to save favorite transforms
- Issue 224: added ABS math function
- Issue 349: Clustering not finding duplicates when facet is showing groupings
- Issue 399: Added Cologne Phonetic clustering for German names

Bugs fixed:

- Issue 102: Process-Panel div sometimes disappears in Google Chrome
- Issue 107: Reconciliation options not showing international characters correctly
- Issue 143: Windows refine.bat file gives NoClassDefFoundError
- Issue 163: Refine doesn't retain the characters for flat or sharp
- Issue 172: inconsistencies in encoding guessing during load
- Issue 184: Support formatting dates into strings
- Issue 185: same reconciliation candidate for two cells seems to be overridden
- Issue 187: Linux start instruction incorrect
- Issue 188: ArrayIndexOutOfBoundsException when importing excel file
- Issue 196: failure and error dialog attempting to remove columns
- Issue 197: New project was modified "0 years ago"
- Issue 202: Sort text with accents
- Issue 203: Please add TextPipe to Related Software page
- Issue 227: Documentation states extensions are mounted at /extensions, but they are really mounted at /extension.
- Issue 228: Import .zip archive fails
- Issue 237: reinterpret() no longer seems to work as expected
- Issue 258: JAVA_HOME ignored if "which java" returns nonzero
- Issue 262: Refine does not start
- Issue 263: & symbol being parsed in url's in xml
- Issue 276: strange character while create new project with a chinese project name
- Issue 294: Exporting date type column to TSV/CSV shows java debugging information instead of value
- Issue 295: Binaries under 'root' user on *nix
- Issue 304: CsvExporter tests fail after commit for issue 294
- Issue 311: "Ignore" and "Skip" fields in the "Create a New Project" form have the same input[name]
- Issue 312: toString(date_val, 'yyyy-MM-dd') doesn't seem to work
- Issue 325: Refine cannot load data from URL when run behind Proxy Server
- Issue 328: Don't retry failed key-based reconciliations
- Issue 334: Fusion Tables CSV import produces NullPointerException
- Issue 351: Error 500 STREAM on Excel export
- Issue 355: Broken images for SchemaAlignment page
- Issue 358: org.json.JSONException: JSON does not allow non-finite numbers.
- Issue 364: Build is broken
- Issue 374: Problems with date functions INC
- Issue 391: Patch to refine.{bat,ini}
- Issue 401: Error in exception handling for ExportRows command
- Issue 404: Intermittent charset detection failure
- Issue 415: Evaluation precedence wrong for arithmetic expressions
- Issue 61: multiple rows per column from 1 xml element


2.0 Release  (November 10, 2010 - first release as Google Refine)

Major Changes:
- New extension architecture.
- Generalized reconciliation framework that allows plugging in standard reconciliation services.
- Support for QA on data loads into Freebase.
- Timeline Facet (Issue 40 and 95)

Features:
- New commands:
  - Fill Down
  - Blank Down
  - Transpose Cells in Columns into Rows
  - Transpose Cells in Rows into Columns (Issue 82)
  - Move Column to Beginning, Move Column to End, Move Column Left, Move Column Right, Reorder Columns
  - Add Column by Fetching URLs
  - Recon commands:
    - Clear recon data for all matching rows
    - Clear recon data for one cell
    - Clear recon data for similar cells
    - Copy recon judgments across columns
- GREL:
  - JSON support
  - New functions: smartSplit, escape, parseJson, hasField, uniques
  - New controls: forEachIndex, forRange, filter
  - New parameters:
    - preserveAllTokens on split function
  - Regexp groups capturing GEL function
- Importers
  - New: RDF exporter (as extension)
  - New: Json importer
  - CSV and TSV importers: added support for ignoring quotation marks
  - Added support for creating a project by pointing to a data file URL.
- Text facet's choice count limit is now configurable through preference page
- Select All and Unselect All buttons in History Extract dialog
- Schema skeleton: support for multiple cells per cell-as nodes, and for conditional links
- Optionally convert strings to numbers during split columns operation

Fixes:
- TSV/CSV exporter bug: Gridworks crashed when there were empty cells.
- Issue  29: Delivered "Collapse whitespace" transformation does not work
- Issue  57: Schema skeleton disappears	 
- Issue  66: Records not excluded with inverted text facet
- Issue  69: ControlFunctionRegistry now correctly registers Chomp expression as "chomp" key.
- Issue  99: Diff for dates fails with "unknown error" always
- Issue 110: Import of single column text file with Postal Codes shows only 1 row with lots of � chars (?)
- Issue 113: Export filtered rows as tsv or csv fails; html and excel OK
- Issue 115: datePart(value,"month") gives zero-based month numbers	 
- Issue 116: CSV/TSV export data includes blank fields for deleted columns
- Issue 121: Importing attached file strips backslashes
- Issue 122: Exporting to Excel on attached project raises server exception
- Issue 125: jsonize not serializing arrays	 
- Issue 126: Large integers formatted in scientific notation in formulas
- Issue 127: Add column from Freebase raises exception	 
- Issue 135: Hangs when setting cell value to large JSON string
- Issue 138: Numbers should be right-justified
- Issue 140: Fix Open Workspace Directory command to work on Windows and Linux	 
- Issue 146: In "Cluster and Edit Column", clicking on entry value to set "Merge?" checkbox does not reflect the final value of operation
- Issue 155: Blank browser shown when non-GZIP format is detected during import	 
- Issue 160: Cancel button on Search for Match dialog sometimes not working
- Issue 161: Authorize error when trying to Sign In before loading to Freebase
- Issue 166: Expression Editor dialog needs UI cleanup on long expressions	 


1.1 Release (May 27, 2010)

Features:
- Row/record sorting (Issue 32)
- CSV exporter (Issue 59)
- Mqlwrite exporter
- Templating exporter (experimental)

Fixes:
- Issue 34: "Behavior of Text Filter is unpredictable when "regular expression" mode is enabled."
  Regex was not compiled with case insensitivity flag.
- Issue 4: "Match All bug with ZIP code". Numeric values in cells were not stringified first
  before comparison.
- Issue 41: "Envelope quotation marks are removed by CSV importer"
- Issue 19: "CSV import is too basic"
- Issue 15: "Ability to rename projects"
- Issue 16: "Column name collision when adding data from Freebase"
- Issue 28: "mql-like preview is not properly unquoting numbers"
- Issue 45: "Renaming Cells with Ctrl-Enter produced ERROR"
  Tentative fix for a concurrent bug.
- Issue 46: "Array literals in GEL"
- Issue 55: "Use stable sorting for text facets sorted by count"
- Issue 53: "Moving the cursor inside the Text Filter box by clicking"
- Issue 58: "Meta facet"
  Supported by the function facetCount()
- Issue 14: "Limiting Freebase load to starred records"
  We load whatever rows that are filtered through, not particularly starred rows.
- Issue 49: "Add Edit Cells / Set Null"
- Issue 30: "Transform dialog should remember preferred language."
- Issue 62: "It'd be nice if URIs were hyperlinked in the data cells"

Other Changes:
- Moved unit tests from JUnit to TestNG


1.0.1 Release (May 12, 2010)

Fixes:
- Issue 2: "Undo History bug" - bulk row starring and flagging operations could not be undone.
- Issue 5: "Localized Windows cause save problems for Gridworks" -
  Windows user IDs that contain unicode characters were not retrieved correctly.
- Issue 10: "OAuth fails on sign in" - due to clock offset.
- Issue 11: "missing "lang" attribute in MQL generated in schema alignment"
- Issue 13: "float rejected from sandbox upload as Json object" - everything was sent as a string.
- Issue 17: "Conflated triples - all rows are producing triple with "s" :" $Name_0"" -
  The Create A New Topic for Each Cell command created shared recon objects.
- Issue 18: "Error converting russian characters during edit of single cell"
- [partial fix] Issue 19: "CSV import is too basic" - fixed for CSV, not for TSV

1.0 Release (May 10, 2010)

First Public Release as Freebase Gridworks

